/*
 * vasaf_systbl1_libpq_01.c
 *
 *
 * Demonio para actualizar la vista materializada 'public._vasaf_systbl_1_vis_modelos_mv';
 * 
 *
 * Creado por : Ing. Mario Alberto Soto Cordones;
 * Version    : 1.0;
 * Fecha      : Septiembre 2005;
 * Sistema    : Vasaf;
 * Plataforma : Linux Fedora Core 4;
 * 
 *   
 *
 */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <sys/time.h>
#include "libpq-fe.h"

static void
exit_nicely(PGconn *conn)
{
	PQfinish(conn);
	exit(1);
}

int
main(int argc, char **argv)
{
        char       *paso;
        const char *autinfo;	
        const char *conninfo;
	PGconn	   *conn;
	PGresult   *res;
	PGnotify   *notify;
	int	   nnotifies;
        int        sock;
        fd_set     input_mask;

   
	if (argc > 1)
		conninfo = argv[1];
	else
		conninfo = "dbname = vasa";

	conn = PQconnectdb(conninfo);

	if (PQstatus(conn) != CONNECTION_OK)
	{
		fprintf(stderr, "Conexion a la Base de Datos fallo: %s",
				PQerrorMessage(conn));
		exit_nicely(conn);
	}
   
        autinfo = "(c)Compu@ll Ingeniera Ltda.\n";

	    res = PQexec(conn, "LISTEN vasaf_systbl1_vis_modelos_mv");
        res = PQexec(conn, "LISTEN his_estadis_mv");
        res = PQexec(conn, "LISTEN his_estadis_mv_sahidep");
        res = PQexec(conn, "LISTEN contabilidad.his_sahidep_mv");
        res = PQexec(conn, "LISTEN his_estadis_mv_sahiaju");

	if (PQresultStatus(res) != PGRES_COMMAND_OK)
	{
                fprintf(stderr, "comando LISTEN fallo: %s", PQerrorMessage(conn));
		PQclear(res);
		exit_nicely(conn);
        }
	PQclear(res); 
	nnotifies = 0;
	while ((nnotifies == 0)) 
	{ 
                sock = PQsocket(conn);
		 if (sock < 0) 
			break; 				
 
		FD_ZERO(&input_mask);
		FD_SET(sock, &input_mask);

		if (select(sock + 1, &input_mask, NULL, NULL, NULL) < 0)
                {
			fprintf(stderr, "select() fallo: %s\n", strerror(errno));
			nnotifies = 1;
                        exit_nicely(conn);
                }

		PQconsumeInput(conn);
		while ((notify = PQnotifies(conn)) != NULL)
		  {
                          
                paso = notify->relname;

                if (strcmp(paso,"vasaf_systbl1_vis_modelos_mv") == 0)
                       {
                       conninfo = "SELECT refresh_matview('public._vasaf_systbl_1_vis_modelos_mv')";
		       } 
		if (strcmp(paso,"his_estadis_mv") == 0 )
                 {
                       conninfo = "SELECT refresh_matview('contabilidad.his_estadis_mv')";
	         }
 
                if (strcmp(paso,"his_estadis_mv_sahidep") == 0)
                  {
                     conninfo = "SELECT refresh_matview('contabilidad.his_estadis_mv')";
                  }

                if (strcmp(paso,"contabilidad.his_sahidep_mv") == 0)
                  {
                    conninfo = "SELECT refresh_matview('contabilidad.his_sahidep_mv')";
                  }

                if (strcmp(paso,"his_estadis_mv_sahiaju") == 0)
                  {
                    conninfo = "SELECT refresh_matview('contabilidad.his_estadis_mv')";
                  }

			fprintf(stderr,
					"Sistema Vasaf ha recibido un ASYNC NOTIFY de '%s' , desde el backend pid %d\n",
					notify->relname, notify->be_pid);
                        fprintf(stderr, "Actualizando Vista Materializada...\n");
                        res = PQexec(conn, conninfo);
                        fprintf(stderr, "Actualizacion de Vista Materializada OK.\n");
                        fprintf(stderr, autinfo);
			PQfreemem(notify);
                        PQclear(res);
                 } 
	} 
        PQfinish(conn);
	return 0; 
}



